# forestvpn_api
ForestVPN defeats content restrictions and censorship to deliver unlimited access to video, music, social media,
and more, from anywhere in the world.


This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.0
- Build package: org.openapitools.codegen.languages.DartClientCodegen
For more information, please visit [https://www.forestvpn.com/](https://www.forestvpn.com/)

## Requirements

Dart 2.0 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  forestvpn_api:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  forestvpn_api:
    path: /path/to/forestvpn_api
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:forestvpn_api/api.dart';

// TODO Configure HTTP Bearer authorization: bearerAuth
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('bearerAuth').setAccessToken(yourTokenGeneratorFunction);

final api_instance = AppleApi();
final appStoreReceiptVerificationRequest = AppStoreReceiptVerificationRequest(); // AppStoreReceiptVerificationRequest | 

try {
    api_instance.verifyAppStoreReceipt(appStoreReceiptVerificationRequest);
} catch (e) {
    print('Exception when calling AppleApi->verifyAppStoreReceipt: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *https://api.forestvpn.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AppleApi* | [**verifyAppStoreReceipt**](doc//AppleApi.md#verifyappstorereceipt) | **POST** /purchase/apple/verify/ | App store receipt verification
*AuthApi* | [**migrateLegacyAuth**](doc//AuthApi.md#migratelegacyauth) | **GET** /legacy/auth/ | Legacy auth migration
*DeviceApi* | [**createDevice**](doc//DeviceApi.md#createdevice) | **POST** /devices/ | Create new device
*DeviceApi* | [**deleteDevice**](doc//DeviceApi.md#deletedevice) | **DELETE** /devices/{deviceID}/ | Delete Device
*DeviceApi* | [**deviceGetByID**](doc//DeviceApi.md#devicegetbyid) | **GET** /devices/{deviceID}/ | Device Info
*DeviceApi* | [**listDeviceBindings**](doc//DeviceApi.md#listdevicebindings) | **GET** /devices/{deviceID}/bindings/ | Device bindings
*DeviceApi* | [**listDevices**](doc//DeviceApi.md#listdevices) | **GET** /devices/ | Device List
*DeviceApi* | [**updateDevice**](doc//DeviceApi.md#updatedevice) | **PATCH** /devices/{deviceID}/ | Update device properties
*FcmApi* | [**createFCMDevice**](doc//FcmApi.md#createfcmdevice) | **POST** /notification/fcm/ | Device registration for push notification through out Firebase Cloud Messaging
*FcmApi* | [**deleteFCMDevice**](doc//FcmApi.md#deletefcmdevice) | **DELETE** /notification/fcm/{registrationID}/ | Delete device
*FcmApi* | [**getFCMDevice**](doc//FcmApi.md#getfcmdevice) | **GET** /notification/fcm/{registrationID}/ | Device info
*FcmApi* | [**updateFCMDevice**](doc//FcmApi.md#updatefcmdevice) | **PATCH** /notification/fcm/{registrationID}/ | Update device properties
*GeoApi* | [**listLocations**](doc//GeoApi.md#listlocations) | **GET** /geo/locations/ | Location list
*GoogleApi* | [**verifyPlayStorePurchase**](doc//GoogleApi.md#verifyplaystorepurchase) | **POST** /purchase/google/verify/ | Play store purchase verification


## Documentation For Models

 - [AppStoreReceiptVerificationRequest](doc//AppStoreReceiptVerificationRequest.md)
 - [Country](doc//Country.md)
 - [CreateDeviceRequest](doc//CreateDeviceRequest.md)
 - [CreateDeviceRequestInfo](doc//CreateDeviceRequestInfo.md)
 - [CreateFCMDeviceRequest](doc//CreateFCMDeviceRequest.md)
 - [Device](doc//Device.md)
 - [DevicePeer](doc//DevicePeer.md)
 - [DeviceStats](doc//DeviceStats.md)
 - [Error](doc//Error.md)
 - [FCMDevice](doc//FCMDevice.md)
 - [LegacyAuthMigrationToken](doc//LegacyAuthMigrationToken.md)
 - [Location](doc//Location.md)
 - [NetworkService](doc//NetworkService.md)
 - [PlayStorePurchaseVerificationRequest](doc//PlayStorePurchaseVerificationRequest.md)
 - [PortForwarding](doc//PortForwarding.md)
 - [Server](doc//Server.md)
 - [UpdateDeviceRequest](doc//UpdateDeviceRequest.md)
 - [UpdateFCMDeviceRequest](doc//UpdateFCMDeviceRequest.md)
 - [WireGuard](doc//WireGuard.md)
 - [WireGuardPeer](doc//WireGuardPeer.md)


## Documentation For Authorization


## bearerAuth

- **Type**: HTTP Bearer authentication


## Author

support@forestvpn.com


