//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;

class DeviceApi {
  DeviceApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Create new device
  ///
  /// Create new device
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [CreateDeviceRequest] createDeviceRequest (required):
  Future<Response> createDeviceWithHttpInfo(CreateDeviceRequest createDeviceRequest) async {
    // Verify required params are set.
    if (createDeviceRequest == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: createDeviceRequest');
    }

    final path = r'/devices/';

    Object postBody = createDeviceRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Create new device
  ///
  /// Create new device
  ///
  /// Parameters:
  ///
  /// * [CreateDeviceRequest] createDeviceRequest (required):
  Future<Device?> createDevice(CreateDeviceRequest createDeviceRequest) async {
    final response = await createDeviceWithHttpInfo(createDeviceRequest);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'Device',
      ) as Device?;
    }
    return Future<Device>.value(null);
  }

  /// Delete Device
  ///
  /// Delete device by id
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<Response> deleteDeviceWithHttpInfo(String deviceID) async {
    // Verify required params are set.
    if (deviceID == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/'.replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Delete Device
  ///
  /// Delete device by id
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<void> deleteDevice(String deviceID) async {
    final response = await deleteDeviceWithHttpInfo(deviceID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Device Info
  ///
  /// Retrieve device info
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<Response> deviceGetByIDWithHttpInfo(String deviceID) async {
    // Verify required params are set.
    if (deviceID == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path = r'/devices/{deviceID}/'.replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device Info
  ///
  /// Retrieve device info
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<Device?> deviceGetByID(String deviceID) async {
    final response = await deviceGetByIDWithHttpInfo(deviceID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'Device',
      ) as Device?;
    }
    return Future<Device>.value(null);
  }

  /// Device bindings
  ///
  /// Each device has bindings to specific servers. This methods returns hostnames where this device binded in a particular time.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<Response> listDeviceBindingsWithHttpInfo(String deviceID) async {
    // Verify required params are set.
    if (deviceID == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }

    final path =
        r'/devices/{deviceID}/bindings/'.replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device bindings
  ///
  /// Each device has bindings to specific servers. This methods returns hostnames where this device binded in a particular time.
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  Future<List<String>> listDeviceBindings(String deviceID) async {
    final response = await listDeviceBindingsWithHttpInfo(deviceID);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<String>')
              as List)
          .cast<String>()
          .toList(growable: false);
    }
    return Future<List<String>>.value(null);
  }

  /// Device List
  ///
  /// Retrieve devices list
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] externalKey:
  Future<Response> listDevicesWithHttpInfo({String? externalKey}) async {
    // Verify required params are set.

    final path = r'/devices/';

    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (externalKey != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', 'external_key', externalKey));
    }

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Device List
  ///
  /// Retrieve devices list
  ///
  /// Parameters:
  ///
  /// * [String] externalKey:
  Future<List<Device>> listDevices({String? externalKey}) async {
    final response = await listDevicesWithHttpInfo(externalKey: externalKey);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'List<Device>')
              as List)
          .cast<Device>()
          .toList(growable: false);
    }
    return Future<List<Device>>.value(null);
  }

  /// Update device properties
  ///
  /// Update device properties
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [UpdateDeviceRequest] updateDeviceRequest (required):
  Future<Response> updateDeviceWithHttpInfo(
      String deviceID, UpdateDeviceRequest updateDeviceRequest) async {
    // Verify required params are set.
    if (deviceID == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: deviceID');
    }
    if (updateDeviceRequest == null) {
      throw ApiException(HttpStatus.badRequest, 'Missing required param: updateDeviceRequest');
    }

    final path = r'/devices/{deviceID}/'.replaceAll('{' + 'deviceID' + '}', deviceID.toString());

    Object postBody = updateDeviceRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['bearerAuth'];

    if (nullableContentType != null &&
        nullableContentType.toLowerCase().startsWith('multipart/form-data')) {
      bool hasFields = false;
      final mp = MultipartRequest("", Uri());
      if (hasFields) {
        postBody = mp;
      }
    } else {}

    return await apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Update device properties
  ///
  /// Update device properties
  ///
  /// Parameters:
  ///
  /// * [String] deviceID (required):
  ///
  /// * [UpdateDeviceRequest] updateDeviceRequest (required):
  Future<Device?> updateDevice(String deviceID, UpdateDeviceRequest updateDeviceRequest) async {
    final response = await updateDeviceWithHttpInfo(deviceID, updateDeviceRequest);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'Device',
      ) as Device?;
    }
    return Future<Device>.value(null);
  }
}
